﻿using System;

namespace _4InARow
{
    // Code by joppiesaus
    public class RowGame
    {
        int rows = 6;
        int columns = 7;

        int numberOfFisches = 0;
        Fisch[] fisch;
        string whosTurn = "Red";
        string columnString = "";

        public RowGame(int Rows = 6, int Columns = 7)
        {
            this.rows = Rows;
            this.columns = Columns;
            this.numberOfFisches = rows * columns;
            fisch = new Fisch[numberOfFisches];

            startUp();
        }

        void startUp()
        {
            for (int i = 1; i < (columns + 1); i++)
            {
                columnString = columnString + i.ToString();
            }

            for (int i = 0; i < numberOfFisches; i++)
            {
                if (fisch[i] == null)
                {
                    fisch[i] = new Fisch();
                }
                else
                {
                    fisch[i].fischColor = Fisch_Box.None;
                    fisch[i].Refresh();
                }
            }
            game();
        }

        void game()//modified for CyberCriminal
        {
            rack();
            bool breakGame = false;
            bool stop = false;
            bool won = false;

            Console.Write(System.Environment.NewLine + System.Environment.NewLine + "It is ");
            Console.ForegroundColor = whichColor();
            Console.Write(whosTurn);
            Console.ResetColor();
            Console.Write("'s turn." + System.Environment.NewLine + "Row: ");

            try
            {
                //int Rw = Convert.ToInt32(Console.ReadLine());
                string toDo = Console.ReadLine();
                if (toDo.ToLower() != "exit")
                {
                    int Rw = Convert.ToInt32(toDo);
                    Console.Write("Column: ");
                    int where = whichArray(Rw, Convert.ToInt32(Console.ReadLine()));

                    if (where + columns <= (rows * columns) - columns)
                        if (fisch[where + columns].fischColor == Fisch_Box.None)
                            stop = true;
                    if (fisch[where].fischColor == Fisch_Box.Red || fisch[where].fischColor == Fisch_Box.Yellow)
                        stop = true;

                    if (!stop)
                    {
                        if (whosTurn == "Red")
                            fisch[where].fischColor = Fisch_Box.Red;
                        else
                            fisch[where].fischColor = Fisch_Box.Yellow;

                        #region stuffAboutWon
                        for (int i = 0; i < numberOfFisches && !won; i++)
                        {
                            if (fisch[i].fischColor != Fisch_Box.None && !won)
                            {
                                won = hasWon(i);
                            }
                        }
                        #endregion
                        changeTurns();
                    }
                }
                else
                {
                    breakGame = true;
                }
            }
            catch { }

            if (!breakGame)
            {
                if (won)
                {
                    changeTurns();
                    this.won();
                }
                else
                {
                    game();
                }
            }
        }

        void rack()
        {
            int writeColumn = 0;
            int rw = 1;
            bool firstTime = true;

            Console.Clear();

            for (int i = 0; i < numberOfFisches; i++)
            {
                if (writeColumn == columns && rw != rows)//should be ==, but I don't want to mess it up completely if an error occurs.
                {
                    rw++;
                    Console.ForegroundColor = ConsoleColor.White;
                    Console.Write(System.Environment.NewLine + rw.ToString() + " ");
                    writeColumn = 0;
                }

                if (firstTime)
                {
                    Console.ForegroundColor = ConsoleColor.White;
                    Console.Write("  " + columnString + System.Environment.NewLine + "1 ");
                    firstTime = false;
                }
                fisch[i].Refresh();
                Console.ForegroundColor = fisch[i].clr;
                Console.Write(fisch[i].fisch);
                writeColumn++;
            }
            Console.ResetColor();
        }

        void won()
        {
            rack();
            Console.ForegroundColor = whichColor();
            Console.Write(System.Environment.NewLine + System.Environment.NewLine + whosTurn + " ");
            Console.ResetColor();
            Console.Write("has won! Congratulations!" + System.Environment.NewLine + "Would you like to play again? (Y / N)" + System.Environment.NewLine);

            string answer = Console.ReadLine();
            if (answer.ToLower() == "yes" || answer.ToLower().Substring(0) == "y")
            {
                startUp();
            }
        }

        void changeTurns()
        {
            if (whosTurn == "Red")
            {
                whosTurn = "Yellow";
            }
            else
            {
                whosTurn = "Red";
            }
        }

        int whichArray(int row, int column)
        {
            row = (row - 1) * this.columns;
            column -= 1;
            return row + column;
        }

        ConsoleColor whichColor()
        {
            if (whosTurn == "Red")
            {
                return ConsoleColor.Red;
            }
            else
            {
                return ConsoleColor.Yellow;
            }
        }

        bool hasWon(int who)
        {
            bool won = false;
            won = hasWonSystem(who, columns);
            if (won != true)
            {
                won = hasWonSystem(who, -columns);
                if (won != true)
                {
                    won = hasWonSystem(who, 1, 1);
                    if (won != true)
                    {
                        won = hasWonSystem(who, -1, 1);
                        if (won != true)
                        {
                            won = hasWonSystem(who, columns, 2);
                        }
                    }
                }
            }
            return won;
        }

        bool hasWonSystem(int who, int attribute, int direction = 0)
        {
            try
            {
                Fisch_Box clr = fisch[who].fischColor;

                if (direction == 0)//vertical
                {
                    if (fisch[who + attribute].fischColor == clr && fisch[who + (attribute + attribute)].fischColor == clr && fisch[who + (attribute * 3)].fischColor == clr)
                        return true;
                    else
                        return false;
                }
                else if (direction == 1)//horizontal
                {
                    if (fisch[who + attribute].fischColor == clr && fisch[who + (attribute + attribute)].fischColor == clr && fisch[who + (attribute * 3)].fischColor == clr)
                        return true;
                    else
                        return false;
                }
                else //vertical / horizontal(angled)
                {
                    if (hasRowColumnWon(who, attribute, 1, clr))
                        return true;
                    else if (hasRowColumnWon(who, attribute, -1, clr))
                        return true;
                    else if (hasRowColumnWon(who, -attribute, 1, clr))
                        return true;
                    else if (hasRowColumnWon(who, -attribute, -1, clr))
                        return true;
                    else
                        return false;
                }
            }
            catch
            {
                return false;
            }
        }

        bool hasRowColumnWon(int which, int attribute, int extra, Fisch_Box clr)
        {
                if (fisch[which + attribute + extra].fischColor == clr && fisch[which + (attribute + attribute) + (extra + extra)].fischColor == clr &&
                    fisch[which + (attribute * 3) + (extra * 3)].fischColor == clr)
                    return true;
                else
                    return false;
        }
    }

    enum Fisch_Box
    {
        None,
        Yellow,
        Red
    }

    class Fisch
    {
        public Fisch_Box fischColor = Fisch_Box.None;
        public string fisch = "O";
        public ConsoleColor clr = ConsoleColor.White;

        public void Refresh()
        {
            //Check the colors
            if (fischColor == Fisch_Box.Red) // RED
            {
                fisch = "R";
                clr = ConsoleColor.Red;
            }
            else if (fischColor == Fisch_Box.Yellow) // YELLOW
            {
                fisch = "Y";
                clr = ConsoleColor.Yellow;
            }
            else //NO FISCH
            {
                clr = ConsoleColor.White;
                fisch = "O";
            }
        }
    }
}
